Skip to main content Skip to footer

Add JavaScript Input Form Mask & Validation Features to Your Web App

Quick Start Guide
What You Will Need

Wijmo

VisualStudio Code

Controls Referenced

InputMask Documentation

InputMask Demo

Tutorial Concept Boost your forms’ UX with a JavaScript input mask control and learn how to format, validate, and enhance user input seamlessly for web and mobile applications.

Forms are the backbone of modern web applications. From registration and checkout flows to feedback surveys and login screens, forms collect critical user information. However, without proper controls, forms can easily lead to errors—such as incorrect phone numbers, incomplete credit card details, or invalid email addresses.

This is where JavaScript Input Mask and JavaScript Input Validation become essential. By combining these techniques, you can guide users as they enter data, ensure proper formatting, and stop invalid submissions before they happen.

In this guide, we’ll walk through building a JavaScript Input Form using Wijmo’s InputMask component. You’ll explore:

Let’s dive in!

Ready to get started? Download Wijmo Today!

Why Use JavaScript Input Masks and Validation

Users make mistakes. Missing digits in a phone number, mistyped dates, or blank required fields all cause problems. Without clear guidance, errors frustrate users and increase support costs.

  • A JavaScript Input Mask ensures data is entered in the correct format (e.g., a phone number like (123) 456-7890).
  • JavaScript Input Validation ensures the data is correct and complete (e.g., not empty, the right length, and correct rules).

Together, they produce polished JavaScript Input Forms that are both intuitive and reliable.

Step 1: Building a JavaScript Input Form

We’ll start by building a small form that collects:

  • Name
  • Email
  • Phone number
  • Social Security number

The form will use Wijmo’s InputMask to enforce formatting and validation:

<div class="form-control">
  <div class="form-header">
    <span>User Information</span>
  </div>
  <form class="form-body" onsubmit="onSubmit(event)">
    <div class="form-footer">
      <button class="form-button" type="submit">Submit</button>
    </div>
  </form>
</div>

We’ll also set up some CSS to give the input form a basic design:

.form-control {
  position: absolute;
  width: 400px;
  height: 300px;
  z-index: 15;
  top: 50%;
  left: 50%;
  margin: -150px 0 0 -200px;
  border-radius: 15px;
  box-shadow: 1px 0 5px -2px rgb(90, 90, 90);
  text-align: center;
}

.form-header {
  height: 50px;
  width: 100%;
  line-height: 50px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  background: rgb(100, 100, 252);
  font-weight: bold;
  font-size: larger;
  color: white;
}

.form-body {
  height: 100%;
  position: relative;
}

.form-footer {
  position: absolute;
  bottom: 75px;
  right: 2px;
  height: 50px;
  width: 100%
}

.form-button {
  float: right;
  margin-top: 10px;
  margin-right: 10px;
  height: 40px;
  width: 100px;
  border-radius: 10px;
  border: 1px solid black;
  background: rgb(100, 100, 252);
  color: white;
  font-size: 16px;
}

.form-button:hover {
  cursor: pointer;
  background: rgb(140, 140, 255);
}

Now, if you load the application in your browser, you’ll see a simple layout with a header and submission button:

JavaScript Input Form

Step 2: Adding JavaScript Input Masks

Next, we’ll bring in Wijmo’s controls and use the MESCIUS CDN to reference the Wijmo files that will be needed:

<link href="https://cdn.mescius.com/wijmo/5.latest/styles/wijmo.min.css" rel="stylesheet"/> 
<script src="https://cdn.mescius.com/wijmo/5.latest/controls/wijmo.min.js"></script>
<script src="https://cdn.mescius.com/wijmo/5.latest/controls/wijmo.input.min.js"></script> 

Now, we’ll use Wijmo to set up the JavaScript Input Masks in the submission form:

nameMask = new wijmo.input.InputMask('#name', {
  placeholder: 'Name'
});

emailMask = new wijmo.input.InputMask('#email', {
  placeholder: 'Email'
});

phoneMask = new wijmo.input.InputMask('#phone', {
  placeholder: 'Phone Number'
});

socialMask = new wijmo.input.InputMask('#social', {
  placeholder: 'Social Security Number'
});

Finally, we’ll add some CSS to style the Input Masks:

.form-element {
  text-align: center;
  margin-top: 15px;
  width: 100%;
}

Now, if you run the application, you should see the following:

JavaScript Input Masks

Step 3: Adding JavaScript Input Validation

Formatting is useful, but we also need validation to prevent incomplete or incorrect entries. Wijmo’s InputMask provides the maskFull property that returns true if all required characters are filled in. Then, if all of the field hasn’t been filled out, we can apply a flag to notify the user that the form is not correctly filled out; in this case, we’ll change the text to red:

function validateMask(ctrl) {
  if (!ctrl.maskFull) {
    ctrl.hostElement.classList.add('state-invalid');
  } else {
    ctrl.hostElement.classList.remove('state-invalid');
  }
}

This method checks if the maskFull property of the InputMask returns true. MaskFull is a Boolean value that returns true if the user has entered the required number of characters by the mask, and false if not. If it does not return true, we add a CSS class named state-invalid to the control.

We’ll add that CSS class to the <script> tag:

.state-invalid {
  color: red;
}

Lastly, we need to associate this method with each of the input masks, which we can do when setting up the masks:

nameMask = new wijmo.input.InputMask('#name', {
  placeholder: 'Name',
  isRequired: true,
  valueChanged: validateMask
});

emailMask = new wijmo.input.InputMask('#email', {
  placeholder: 'Email',
  isRequired: true,
  valueChanged: validateMask
});

phoneMask = new wijmo.input.InputMask('#phone', {
  placeholder: 'Phone Number',
  isRequired: true,
  valueChanged: validateMask
});

socialMask = new wijmo.input.InputMask('#social', {
  placeholder: 'Social Security Number',
  isRequired: true,
  valueChanged: validateMask
});

We’re also setting a property called isRequired to true, so that the form knows that these fields are required to be filled out.

Now, when a user enters an invalid input, it will flag the error and display the text in red. However, how does the input mask know that we’ve entered an invalid input? We’ll take a look at that next.

Step 4: Customizing the JavaScript Input Form

With Wijmo’s InputMask, you can tailor the experience further:

  • Prompt Characters: Guide users with different placeholders (e.g., # or *)
  • Raw Values: Access unformatted input for backend processing (e.g., 1234567890 instead of (123) 456-7890)
  • Custom Masks: Define your own formats for IDs, postal codes, or business-specific inputs

For example, here’s how we enforce formats for phone and SSN fields:

phoneMask = new wijmo.input.InputMask('#phone', {
  placeholder: 'Phone Number',
  isRequired: true,
  valueChanged: validateMask,
  mask: '000-000-0000'
});

socialMask = new wijmo.input.InputMask('#social', {
  placeholder: 'Social Security Number',
  isRequired: true,
  valueChanged: validateMask,
  mask: '000-00-0000'
});

For each of these JavaScript input masks, we set a promptChar to display in the field and define the format for how user input is displayed through the mask property.

Now, when we run the application, we should see the following:

Custom JavaScript Input Form

And thanks to the validation customization that we’ve set up, when improperly submitted, we’ll see the following:

JavaScript Input Validation

Step 5: Handling Form Submission

Finally, let’s capture the data when the form is submitted:

function isFormComplete() {
  const name = document.getElementById('name').value;
  const email = document.getElementById('email').value;
  return (
    name !== '' &&
    email !== '' &&
    phone.maskFull &&
    social.maskFull
  );
}

function onSubmit(event) {
  event.preventDefault();
  if (isFormComplete()) {
    alert(
      `User Information:\nName: ${document.getElementById('name').value}\nEmail: ${document.getElementById('email').value}\nPhone: ${phone.value}\nSSN: ${social.value}`
    );
  } else {
    alert('Please complete all fields correctly.');
  }
}

With this, your JavaScript Input Form is fully functional: masked, validated, and ready to handle user submissions. If you run the application and correctly fill out all of the JavaScript Input Masks, when submitting the form, you should see the following alert:

Final JavaScript Input Form

Ready to check it out? Download Wijmo Today!

Conclusion

Using JavaScript Input Mask and JavaScript Input Validation with Wijmo’s InputMask control makes it easy to build forms that are both user-friendly and reliable. By guiding user input and preventing errors, you deliver a smoother user experience and cleaner data for your application.

For more information, explore our demos, documentation, and API references for developers.

Happy coding!

Tags:

comments powered by Disqus

Skip to main content Skip to footer

Add React Input Form Mask & Validation Features to Your Web App

  • 0 Comments
Quick Start Guide
What You Will Need

Wijmo

React

Controls Referenced

InputMask

Tutorial Concept Adding Input Form Mask & Validation to React Apps - Use Wijmo's InputMask control to create a feature-rich input form in React

Form elements are a common way to collect information that your website requires from users. They typically consist of <input> elements, checkboxes, radio buttons, and a button for users to submit the information they entered. However, standard <input> elements allow users to enter whatever they want, and if you want to standardize the information they entered, it's on the developers to implement that functionality.

That is where the InputMask comes in; Wijmo’s React InputMask control allows developers to implement masks, predefined formats for the input field, easily. This will enable you to restrict the number of characters that users can enter in the mask, the prompt characters displayed in the control, and whether the control allows users to enter numbers, letters, or both.

In this article, we’ll be outlining the following steps:

If you’d like to download the project for yourself, you can find it on GitHub. Also, the code is available on StackBlitz.

Interested in what Wijmo has to offer? You can download the library here!

Creating a React Form

The first thing that we’ll go over is creating the React form. Open up the App.js file and add the following markup for the form:

<div class="form-control">
  <div class="form-header">
    <span>User Information</span>
  </div>
  <form class="form-body" onSubmit={submitForm}>
    <div class="form-footer">
      <button class="form-button" type="submit">Submit</button>
    </div>
  </form>
</div>

We’re using a form to aggregate the data from the user and React’s onSubmit markup to tie a method to the form to handle when the form gets submitted. Be sure to add this function above the markup so we don't get an error:

function submitForm(event) {}

The other thing that we’ll do in this section is add styles for the form. Open up the App.css file and add the following CSS:

.form-control {
  position: absolute;
  width: 400px;
  height: 300px;
  z-index: 15;
  top: 50%;
  left: 50%;
  margin: -150px 0 0 -200px;
  border-radius: 15px;
  box-shadow: 1px 0 5px -2px rgb(90, 90, 90);
  text-align: center;
}

.form-header {
  height: 50px;
  width: 100%;
  line-height: 50px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  background: rgb(100, 100, 252);
  font-weight: bold;
  font-size: larger;
  color: white;
}

.form-body {
  height: 100%;
  position: relative;
}

.form-footer {
  position: absolute;
  bottom: 75px;
  right: 2px;
  height: 50px;
  width: 100%
}

.form-button {
  float: right;
  margin-top: 10px;
  margin-right: 10px;
  height: 40px;
  width: 100px;
  border-radius: 10px;
  border: 1px solid black;
  background: rgb(100, 100, 252);
  color: white;
  font-size: 16px;
}

.form-button:hover {
  cursor: pointer;
  background: rgb(140, 140, 255);
}

The CSS we’ve just written will center the form on the page and style our header, footer, and button elements. Now, if you run the application, you should see the following:

User Information

Implementing Wijmo’s React InputMask

Now that the form has been created, it's time to add our InputMasks. To use Wijmo, we will need to add the library to our project. Open up your command prompt, navigate to where your project is stored, and run the following:

npm i @mescius/wijmo.react.all

Once NPM has installed all the files, open up the App.js file. Now that we’ve included Wijmo, we need to import the required Wijmo files to our product:

import * as wjcCore from '@mescius/wijmo';
import * as wjcInput from '@mescius/wijmo.react.input';

The last thing to do is add Wijmo’s CSS library to our application. Open up the index.css file and add the following:

@import '@mescius/wijmo.styles/themes/wijmo.theme.material.css';
body {
  box-sizing: border-box;
  font-family: sans-serif;
}

With all of that done, we can now use Wijmo’s React InputMask. Go back to the App.js file and add the following markup inside of the <form> element:

<div className="form-element">
  <wjcInput.InputMask ref={name} id="name" placeholder="Name"></wjcInput.InputMask>
</div>
<div className="form-element">
  <wjcInput.InputMask ref={email} id="email" placeholder="Email"></wjcInput.InputMask>
</div>
<div className="form-element">
  <wjcInput.InputMask ref={phone} id="phone" placeholder="Phone Number"></wjcInput.InputMask>
</div>
<div className="form-element">
  <wjcInput.InputMask ref={social} id="social" placeholder="Social Security Number"></wjcInput.InputMask>
</div>

Here, we’re implementing four InputMasks: one for name, email, phone number, and social security number. We’re also setting a placeholder value for each mask, which will display inside the React InputMask to let users know the expected input.

We also need to import useRef and add the following code to our App.js file:

import { useRef } from "react";

const name = useRef();
const email = useRef();
const phone = useRef();
const social = useRef();

The last thing that we’ll need to do is add some CSS to style the InputMasks in our App.css file:

.form-element {
  text-align: center;
  margin-top: 15px;
  width: 100%;
}

Now, if you run the application, you should see the following:

User Information

Defining the Mask and Prompt Characters

Now that we’ve implemented the InputMasks, we’ll review how to set the mask and prompt characters for the controls. In this sample, we want to define a mask and prompt characters for the phone number and social security number inputs. We’re going to modify the markup for both of these InputMasks:

<wjcInput.InputMask ref={phone} id="phone" placeholder="Phone Number" mask="000-000-0000" isRequired={false} value="" promptChar="#"></wjcInput.InputMask>
<wjcInput.InputMask ref={social} id="social" placeholder="Social Security Number" mask="000-00-0000" isRequired={false} value="" promptChar="*"></wjcInput.InputMask>

By using number characters in the mask property, we’re telling the InputMask that we only want to accept numbers when typing in the control and how many characters we require the user to input. Setting the prompChar property tells the control what character we want to show for the values that we still need input for. And finally, setting the isRequired and value properties will allow our placeholder to continue to display instead of defaulting to displaying the prompt characters. Now, if we run the application and begin typing in either the phone or social InputMask, we should see the following:

User Information

As you can see, when we type in either of those InputMasks, it will display the prompt character for the remaining characters that the control expects.

Validating the User’s Information

The last thing we’ll discuss in this article is how we can validate the user’s information. In the case of this form, we want them to enter information in the “Name” and “Email” InputMasks, and we want to make sure that the “Phone Number” and “Social Security Number” InputMasks have been completely filled out.

We’ll first make sure that users know that the last two InputMasks need to be completely filled out. We’ll use Wijmo’s React InputMask valueChanged event to do that. Inside of the markup, add the event to the control:

<wjcInput.InputMask ref={phone} id="phone" placeholder="Phone Number" mask="000-000-0000" isRequired={false} value="" promptChar="#" valueChanged={valueChanged}></wjcInput.InputMask>
<wjcInput.InputMask ref={social} id="social" placeholder="Social Security Number" mask="000-00-0000" isRequired={false} value="" promptChar="*" valueChanged={valueChanged}></wjcInput.InputMask>

Now, inside the App.js file, we’ll implement the following method:

function valueChanged(ctrl) {
  wjcCore.toggleClass(ctrl.hostElement, 'state-invalid', !ctrl.maskFull);
}

This method checks if the maskFull property of the InputMask returns true; maskFull is a Boolean value that returns true if the user has entered the required number of characters by the mask and false if not. If it does not return true, then we add a CSS class named state-invalid to the control.

We’ll add that CSS class to the App.css file:

.state-invalid {
  color: red;
}

Now, as we type in the “Phone Number” or “Social Security Number” InputMasks, we’ll see the following:

User Information

As you can see, if the mask has not been filled out completely, the text will display as red.

Next, we’ll add a method to check and see if the user has filled out all of the InputMasks, as well as update the onSubmit() method to determine whether or not to submit the form:

const name = useRef();
const email = useRef();
const phone = useRef();
const social = useRef();

function isFormComplete() {
  if(name.current.control.value !== '' && name.current.control.value !== '' && name.current.control.maskFull && name.current.control.maskFull) {
    return true;
  }
  return false;
}

function submitForm(event) {
  if(isFormComplete()) {
    alert('User Information:\nName: ' + name.current.control.value + 
    '\nEmail: ' + email.current.control.value + '\nPhone Number: ' + phone.current.control.value + 
    '\nSSN: ' + social.current.control.value)
  } else {
    event.preventDefault();
  }
}

Now, if we run the app and properly fill out all of the InputMasks, we’ll see the following alert:

LocalHost

Conclusion

As you can see, you can easily build forms using Wijmo’s React InputMask control. If you'd like more information, we've got demos, documentation, and API references for developers. If you'd like to download the finished application, you can find it on GitHub and on StackBlitz.

Interested in what Wijmo has to offer? You can download the library here!

Happy coding!

Skip to main content Skip to footer

Add Angular Input Form Mask & Validation Features to Your Web App

Quick Start Guide
What You Will Need

Wijmo

Angular

Controls Referenced

InputMask

Tutorial Concept Adding Input Form Mask & Validation to Angular Apps - Use Wijmo's InputMask control to create a feature-rich input form in Angular

Form elements are a common way to collect information that your website requires from users. They typically consist of <input> elements, checkboxes, radio buttons, and a button for users to submit the information they entered. However, standard <input> elements allow users to enter whatever they want, and if you're going to standardize the information that they entered, it's on the developers to implement that functionality.

That is where the InputMask comes in; Wijmo’s Angular InputMask control allows developers to implement masks and predefined formats for the input field quickly. This will enable you to restrict the number of characters that users can enter in the mask, the prompt characters displayed in the control, and whether the control allows users to enter numbers, letters, or both.

In this article, we’ll be outlining the following steps:

If you’d like to see the finished project you can find it on StackBlitz.

If you're interested in seeing what more Wijmo has to offer, you can download the library here.

Creating an Angular Form

Before we go about implementing the InputMask control, we’re going to need to need the Angular CLI installed if you don't already:

npm install -g @angular/cli

Next, we will create a new Angular application:

ng new inputFormMaskApp --no-standalone

The project wizard will ask you what kind of styling you want to use, choose CSS. It will then ask you if you want Server Side Rendering. For this example we will choose no:

 

Angular CLI Options

 

Next, we need to create the <form> element that will make use of the InputMasks. We’re going to be making use of Angular’s FormsModule and ReactiveFormsModule modules, so we’ll import them in the app.module.ts file:

import { FormsModule, ReactiveFormsModule } from '@angular/forms';
...
imports: [
  BrowserModule,
  FormsModule,
  ReactiveFormsModule
]

Now that we’ve imported the required modules, we’re going to jump over to the app.component.html file and add the markup for the form:

<div class="form-control">
  <div class="form-header">
    <span>User Information</span>
  </div>
  <form class="form-body" [formGroup]="inputForm" (ngSubmit)="onSubmit()">
    <div class="form-footer">
      <button class="form-button" type="submit">Submit</button>
    </div>
  </form>
</div>

We’re using Angular’s FormGroup to aggregate the data from the form and ngSubmit to handle when the form gets submitted.

Next, we’re going to open the app.component.ts file to create our FormGroup:

import { FormBuilder } from '@angular/forms';
...
export class AppComponent {
  title = 'inputFormMaskApp';

  inputForm= this.formBuilder.group({
    name: '',
    email: '',
    phone: '',
    social: ''
  });
  
  constructor(private formBuilder: FormBuilder) {}
  
  onSubmit(): void {
    this.inputForm.reset();
  }
}

Here, we’re using FormBuilder to create our importForm, which will manage the values for all of the different InputMasks in the form; in this case, we’ll ask the user for their name, email, phone number, and social security number.

The last thing we’ll do in this section is add styles for the form. Open up the app.component.css file and add the following CSS:

.form-control {
  position: absolute;
  width: 400px;
  height: 300px;
  z-index: 15;
  top: 50%;
  left: 50%;
  margin: -150px 0 0 -200px;
  border-radius: 15px;
  box-shadow: 1px 0 5px -2px rgb(90, 90, 90);
  text-align: center;
}

.form-header {
  height: 50px;
  width: 100%;
  line-height: 50px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  background: rgb(100, 100, 252);
  font-weight: bold;
  font-size: larger;
  color: white;
}

.form-body {
  height: 100%;
  position: relative;
}

.form-footer {
  position: absolute;
  bottom: 75px;
  right: 2px;
  height: 50px;
  width: 100%
}

.form-button {
  float: right;
  margin-top: 10px;
  margin-right: 10px;
  height: 40px;
  width: 100px;
  border-radius: 10px;
  border: 1px solid black;
  background: rgb(100, 100, 252);
  color: white;
  font-size: 16px;
}

.form-button:hover {
  cursor: pointer;
  background: rgb(140, 140, 255);
}

The CSS we’ve just written will center the form on the page and style our header, footer, and button elements. Now, if you run the application, you should see the following:

User Information

Implementing Wijmo’s Angular InputMask

Now that the form has been created, it's time to add our InputMasks. To use Wijmo, we will need to add the library to our project. Open up your command prompt, navigate to where your project is stored, and run the following:

npm i @mescius/wijmo.angular2.all

Once NPM has installed all of the files, open up the app.module.ts file and import the following module:

import { WjInputModule } from '@mescius/wijmo.angular2.input';
...
import: [
  BrowserModule,
  FormsModule,
  ReactiveFormsModule,
  WjInputModule
]

The last thing to do is add Wijmo’s CSS library to our application. Open up the styles.css file and add the following:

@import '@mescius/wijmo.styles/themes/wijmo.theme.material.css';
body {
  box-sizing: boder-box;
  font-family: sans-serif;
}

With all of that done, we can now make use of Wijmo’s Angular InputMask. Go back to the app.component.html and add the following markup inside of the <form> element:

<div class="form-element">
  <wj-input-mask #name id="name" [placeholder]="'Name'" formControlName="name"></wj-input-mask>
</div>
<div class="form-element">
  <wj-input-mask #email id="email" [placeholder]="'Email'" formControlName="email"></wj-input-mask>
</div>
<div class="form-element">
  <wj-input-mask #phone id="phone" [placeholder]="'Phone Number'" formControlName="phone"></wj-input-mask>
</div>
<div class="form-element">
  <wj-input-mask #social id="social" [placeholder]="'Social Security Number'" formControlName="social"></wj-input-mask>
</div>

Here, we’re implementing 4 InputMasks; one for name, email, phone number, and social security number. We’re also setting a placeholder value for each of the masks, and we’re tying them to the inputForm object in the app.component.ts file using the formControlName property.

The last thing that we’ll need to do is add some CSS to style the InputMasks:

.form-element {
  text-align: center;
  margin-top: 15px;
  width: 100%;
}

Now, if you run the application, you should see the following:

FormControl Name

Defining the Mask and Prompt Characters

Now that we’ve implemented the InputMasks, we’re going to go over how to set the mask and prompt characters for the controls. In this sample, we want to define a mask and prompt characters for the phone number and social security number inputs. We’re going to modify the markup in the app.component.html file for both of these InputMasks:

<wj-input-mask #phone id="phone" [mask]="'000-000-0000'" [placeholder]="'Phone Number'" [isRequired]="false" [promptChar]="'#'" [value]="''" formControlName="phone"></wj-input-mask>
<wj-input-mask #social id="social" [mask]="'000-00-0000'" [placeholder]="'Social Security Number'" [isRequired]="false" [promptChar]="'*'" [value]="''" formControlName="social"></wj-input-mask>

By using number characters in the mask property, we’re telling the InputMask that we only want to accept numbers when typing in the control and how many characters we require the user to input. Setting the prompChar property tells the control what character we want to show for the values we still require input for. And finally, setting the isRequired and value properties will allow our placeholder to continue to display instead of defaulting to displaying the prompt characters. Now, if we run the application and begin typing in either the phone or social InputMask, we should see the following:

prompChar

As you can see, when we type in either of those InputMasks, it will display the prompt character for the remaining characters that the control expects.

Validating the User’s Information

The last thing we’ll discuss in this article is how we can validate the user’s information. In the case of this form, we want them to enter information in the “Name” and “Email” InputMasks, and we want to make sure that the “Phone Number” and “Social Security Number” InputMasks have been completely filled out.

The first thing that we’ll do is make sure that users know that the last 2 InputMasks need to be completely filled out. To do that, we’ll be using Wijmo’s Angular InputMask valueChanged event. Inside of the markup, add the event to the control:

<wj-input-mask #phone id="phone" [mask]="'000-000-0000'" [placeholder]="'Phone Number'" [isRequired]="false" [promptChar]="'#'" [value]="''" (valueChanged)="validateInput(phone)" formControlName="phone"></wj-input-mask>
<wj-input-mask #social id="social" [mask]="'000-00-0000'" [placeholder]="'Social Security Number'" [isRequired]="false" [promptChar]="'*'" [value]="''" (valueChanged)="validateInput(social)" formControlName="social"></wj-input-mask>

Now, inside of the app.component.ts file, we’ll implement the following method:

import * as wjCore from '@mescius/wijmo';
import * as wjInput from '@mescius/wijmo.input';
import * as wjcInput from '@mescius/wijmo.angular2.input';

validateInput(control: wjInput.InputMask) {
  wjCore.toggleClass(control.hostElement, 'state-invalid', !control.maskFull);
}

This method checks if the maskFull property of the InputMask returns true; maskFull is a boolean value that returns true if the user has entered the required number of characters by the mask and false if not. If it does not return true, then we add a CSS class named state-invalid to the control.

We’ll add that CSS class to the app.component.css file:

.state-invalid {
  color: red;
}

Now, as we type in the “Phone Number” or “Social Security Number” InputMasks, we’ll see the following:

InputMask

As you can see, if the mask has not been filled out completely, the text will display as red.

Next, we’ll add a method to check and see if the user has filled out all of the InputMasks, as well as update the onSubmit() method to determine whether or not to submit the form. Also, don't forget to import ViewChild from @angular/core:

@ViewChild('name') name: wjcInput.WjInputMask;
@ViewChild('email') email: wjcInput.WjInputMask;
@ViewChild('phone') phone: wjcInput.WjInputMask;
@ViewChild('social') social: wjcInput.WjInputMask;

isFormComplete() {
  if(this.name.value != '' && this.email.value != '' && this.phone.maskFull && this.social.maskFull) {
    return true
  }
  return false;
}

onSubmit(): void {
  if(this.isFormComplete()) {
    // Display user info on form submission
    alert('User Information:\nName: ' + this.inputForm.value.name + 
      '\nEmail: ' + this.inputForm.value.email + '\nPhone Number: ' + this.inputForm.value.phone + 
      '\nSSN: ' + this.inputForm.value.phone);
    this.inputForm.reset();
  }
}

Now, if we run the app and correctly fill out all of the InputMasks, we’ll see the following alert:

localhost:4200

Conclusion

As you can see, you can easily build forms using Angular Forms and Wijmo’s Angular InputMask control. If you'd like more information, we have demos, documentation, and API references for developers. If you'd like to view the finished sample application, you can find it here.

If you're interested in seeing what more Wijmo has to offer, you can download the library here.

Happy coding!

comments powered by Disqus

Skip to main content Skip to footer

Add Vue Input Form Mask & Validation Features to Your Web App

  • 0 Comments

Form elements are a common way to collect information that your website requires from users. They typically consist of <input> elements, checkboxes, radio buttons, and a button for users to submit the information they entered. However, standard <input> elements allow users to enter whatever they want, and if you want to standardize the information they entered, it’s on the developers to implement that functionality.

That is where the InputMask comes in; Wijmo’s Vue InputMask control allows developers to implement masks and predefined formats for the input field easily. This will enable you to restrict the number of characters that users can enter in the mask, the prompt characters displayed in the control, and whether the control allows users to enter numbers, letters, or both.

In this article, we’ll be outlining the following steps:

If you’d like to download the project for yourself, you can find it on GitHub or see it running on JS CodeMine.

Interested in seeing what more Wijmo has to offer? You can download the library here!

Creating a Vue Form

The first thing that we’ll go over is creating the Vue form. Open up the App.vue file and add the following markup for the form to the HTML template:

<div class="form-control">
  <div class="form-header">
    <span>User Information</span>
  </div>
  <form class="form-body" v-on:submit="onSubmit">
    <div class="form-footer">
      <button class="form-button" type="submit">Submit</button>
    </div>
  </form>
</div>

We’re using a form to aggregate the data from the user and Vue’s v-on:submit directive to handle when the form gets submitted.

The other thing that we’ll do in this section is add styles for the form. Inside of the <style> tags of the App.vue file and add the following CSS:

.form-control {
  position: absolute;
  width: 400px;
  height: 300px;
  z-index: 15;
  top: 50%;
  left: 50%;
  margin: -150px 0 0 -200px;
  border-radius: 15px;
  box-shadow: 1px 0 5px -2px rgb(90, 90, 90);
  text-align: center;
}

.form-header {
  height: 50px;
  width: 100%;
  line-height: 50px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  background: rgb(100, 100, 252);
  font-weight: bold;
  font-size: larger;
  color: white;
}

.form-body {
  height: 100%;
  position: relative;
}

.form-footer {
  position: absolute;
  bottom: 75px;
  right: 2px;
  height: 50px;
  width: 100%
}

.form-button {
  float: right;
  margin-top: 10px;
  margin-right: 10px;
  height: 40px;
  width: 100px;
  border-radius: 10px;
  border: 1px solid black;
  background: rgb(100, 100, 252);
  color: white;
  font-size: 16px;
}

.form-button:hover {
  cursor: pointer;
  background: rgb(140, 140, 255);
}

The CSS that we’ve just written will center the form on the page, as well as style our header, footer, and button elements. Now, if you run the application, you should see the following:

Vue

Implementing Wijmo’s Vue InputMask

Now that the form has been created, it's time to add our InputMasks. To use Wijmo, we will need to add the library to our project. Open up your command prompt, navigate to where your project is stored, and run the following:

npm i @grapecity/wijmo.vue2.all

Once NPM has installed all of the files, open up the App.vue file and import the following files inside of the <script> tags:

import '@grapecity/wijmo.styles/themes/wijmo.theme.material.css';
import * as wjcCore from '@grapecity/wijmo';
import * as wjcInput from '@grapecity/wijmo.vue2.input';

This loads in Wijmo’s CSS styles, as well as Wijmo’s core and input Vue module.

We’ll also need to let Vue know about the component we’ll be using, and the markup used to display the component:

export default {
  name: 'App',
  components: {
    'wj-input-mask': wjcInput.WjInputMask
  }
}

With all of that done, we can now make use of Wijmo’s Vue InputMask. Jump back up to the <template> and add the following markup inside of the <form> element:

<div class="form-element">
<wj-input-mask ref="name" id="name" :placeholder="'Name'"></wj-input-mask>
</div>
<div class="form-element">
<wj-input-mask ref="email" id="email" :placeholder="'Email'"></wj-input-mask>
</div>
<div class="form-element">
<wj-input-mask ref="phone" id="phone" :placeholder="'Phone Number'"></wj-input-mask>
</div>
<div class="form-element">
<wj-input-mask ref="social" id="social" :placeholder="'Social Security Number'"></wj-input-mask>
</div>

Here, we’re implementing 4 InputMasks; one for name, email, phone number, and social security number. We’re also setting a placeholder value for each of the masks, and we’re tying them to references so we can access these controls inside our <script> tags.

The last thing that we’ll need to do is add some CSS to style the InputMasks:

.form-element {
  text-align: center;
  margin-top: 15px;
  width: 100%;
}

Now, if you run the application, you should see the following:

Vue

Defining the Mask and Prompt Characters

Now that we’ve implemented the InputMasks, we’ll review how to set the mask and prompt characters for the controls. In this sample, we want to define a mask and prompt characters for the phone number and social security number inputs. We’re going to modify the markup for both of these InputMasks:

<wj-input-mask ref="phone" id="phone" :mask="'000-000-0000'" :placeholder="'Phone Number'" :isRequired="false" :promptChar="'#'" :value="''"></wj-input-mask>
<wj-input-mask ref="social" id="social" :mask="'000-00-0000'" :placeholder="'Social Security Number'" :isRequired="false" :promptChar="'*'" :value="''"></wj-input-mask>

By using number characters in the mask property, we’re telling the InputMask that we only want to accept numbers when typing in the control and how many characters we require the user to input. Setting the prompChar property tells the control what character we want to show for the values we still require input for.

And finally, setting the isRequired and value properties will allow our placeholder to continue to display instead of defaulting to displaying the prompt characters. Now, if we run the application and begin typing in either the phone or social InputMask, we should see the following:

Vue

As you can see, when we type in either of those InputMasks, it will display the prompt character for the remaining characters that the control expects.

Validating the User’s Information

The last thing we’ll discuss in this article is how we can validate the user’s information. In the case of this form, we want them to enter information in the “Name” and “Email” InputMasks, and we want to make sure that the “Phone Number” and “Social Security Number” InputMasks have been filled out.

We’ll first ensure that users know that the last two InputMasks must be completely filled out. We’ll use Wijmo’s Vue InputMask valueChanged event to do that. Inside of the markup, add the event to the control:

<wj-input-mask ref="phone" id="phone" :mask="'000-000-0000'" :placeholder="'Phone Number'" :isRequired="false" :promptChar="'#'" :value="''" :valueChanged="validateMask"></wj-input-mask>
<wj-input-mask ref="social" id="social" :mask="'000-00-0000'" :placeholder="'Social Security Number'" :isRequired="false" :promptChar="'*'" :value="''" :valueChanged="validateMask"></wj-input-mask>

Now, inside the component, we’ll implement the following method:

methods: {
  validateMask: function(ctrl) {
    wjcCore.toggleClasee(ctrl.hostElement, 'state-invalid', !ctrl.maskFull);
  }
}

This method checks if the maskFull property of the InputMask returns true; maskFull is a Boolean value that returns true if the user has entered the required number of characters by the mask and false if not. If it does not return true, then we add a CSS class named state-invalid to the control.

We’ll add that CSS class to the <script> tag:

.state-invalid {
  color: red;
}

Now, as we type in the “Phone Number” or “Social Security Number” InputMasks, we’ll see the following:

Vue

As you can see, if the mask has not been filled out completely, the text will display as red.

Next, we’ll add a method to check and see if the user has filled out all of the InputMasks, as well as update the onSubmit() method to determine whether or not to submit the form:

methods: {
  validateMask: function(ctrl) {
    wjcCore.toggleClasee(ctrl.hostElement, 'state-invalid', !ctrl.maskFull);
  }
  isFormComplete: function() {
    if(this.$refs.name.control.value !== '' && this.$refs.email.control.value !== '' && this.$refs.phone.control.maskFull && this.$refs.social.control.maskFull) {
      return true;
    }
    return false;
  }
  onSubmit: function() {
    if(this.isFormComplete()) {
      // Display user info on form submission
      alert('User Information:\nName: ' + this.$refs.name.control.value + 
      '\nEmail: ' + this.$refs.email.control.value + '\nPhone Number: ' + this.$refs.phone.control.value + 
      '\nSSN: ' + this.$refs.social.control.value);
    }
  }
}

Now, if we run the app and correctly fill out all of the InputMasks, we’ll see the following alert:

Vue

Conclusion

As you can see, you can easily build forms using Wijmo’s Vue InputMask control. If you'd like more information, we've got demos, documentation, and API references for developers.

If you’d like to download the project for yourself, you can find it on GitHub or see it running on JS CodeMine.

Interested in seeing what more Wijmo has to offer? You can download the library here!

Happy coding!

 

Tags: